/*********************************************************************
*                   (c) SEGGER Microcontroller GmbH                  *
*                        The Embedded Experts                        *
*                           www.segger.com                           *
**********************************************************************

-------------------------- END-OF-HEADER -----------------------------

File    : nRF_Target.js
Purpose : Example init of SWO Pin for nRF52832 device series.

*/

function Reset() {
  TargetInterface.resetAndStop();
}

function EnableTrace(traceInterfaceType) {
  var _TRACECONFIG_ADDR    = 0x4000055C;
  var _COREDEBUG_DMCR_ADDR = 0xE000EDFC;
  var _NRF_P18_ADDR        = 0x50000748;
  var v;

  v = TargetInterface.peekUint32(_COREDEBUG_DMCR_ADDR);
  v |= (1 << 24);  // Set TRCENA bit
  TargetInterface.pokeUint32(_COREDEBUG_DMCR_ADDR, v);
  //
  // Config SWO Clock source
  //
  v = TargetInterface.peekUint32(_TRACECONFIG_ADDR);
  v &= ~(3 << 16);
  v |=  (1 << 16);
  TargetInterface.pokeUint32(_TRACECONFIG_ADDR, v);
  //
  // Set SWO Pin
  //
  v = TargetInterface.peekUint32(_NRF_P18_ADDR);
  v |=  (3 << 8);  // Set high drive
  v &= ~(1 << 1);  // Set input buffer
  v |=  (1 << 0);  // Set output dir
  TargetInterface.pokeUint32(_NRF_P18_ADDR, v);
}

